<?
/*
 Script zur UHRZEITZUWEISUNG aus dem Webfrontend
 
 Format:  HH:MM
 Example: 20:09

 14.07.2012 - R0.1
 Ist die Uhrzeiteingabe kleiner als die aktuelle Systemzeit,
 wird TAG+1 auf die $SysTimeInput geschrieben

 18.07.2012 - R0.2
 Einfuegen der S7-Verbindungsueberwachung

 21.07.2012 - R0.3
 Auslesen der Verbindungsinstanz hat sich mit der IPS2.6 geaendert !!
 ==> daher wird ab 2.6 die "ConnectionID" verwendet
 ==> bis 2.5 aber die "ParentID"
 
 
*/

include_once ('./common_function.php');
include_once ('./s7_function.php');

//hier die S7-InstanzID eintragen die zu schreiben verwendet werden soll
$S7_Instanz_ID       = 49043;


if($_IPS['SENDER'] == "WebFront")
  {
   if ((is_numeric(substr($_IPS['VALUE'],0,2)) == true) and
	    (((int)substr($_IPS['VALUE'],0,2)) >= 0  ) and
	    (((int)substr($_IPS['VALUE'],0,2)) <= 23 ) and
	    ((substr($_IPS['VALUE'],2,1) == ":") or (substr($_IPS['VALUE'],2,1) == " ")) and
       (is_numeric(substr($_IPS['VALUE'],3,2)) == true) and
       (((int)substr($_IPS['VALUE'],3,2)) >= 0  ) and
	    (((int)substr($_IPS['VALUE'],3,2)) <= 59 )
		)
      {

       //S7-Verindung checken **********************************************

         //Check ob S7-Instanz okay ???
         $instance = IPS_GetInstance($S7_Instanz_ID);
         if ($instance['InstanceStatus'] >= 104)
            {
             IPS_LogMessage("WEBFRONT_TIME", "Fehler in der S7-Instanz: " . $S7_Instanz_ID);
             echo("Fehler in der S7-Instanz: " . $S7_Instanz_ID);
             return;
            }


         $S7_ParentInstanz_ID = 0;
         if ((float) IPS_GetKernelVersion() >= 2.6)
				{
             $S7_ParentInstanz_ID = $instance['ConnectionID'];
            }
		   else
				{
             $S7_ParentInstanz_ID = $instance['ParentID'];
				}

			if ($S7_ParentInstanz_ID == 0)
				{
				echo ("Error: Kann ID der Verbindungsinstanz nicht ermitteln !!");
				return;
				}
				

         $ReconnectCounter = 0;
         
         while (S7_GetOpen($S7_ParentInstanz_ID) == false)
               {
                $S7_connect = S7_SetOpen($S7_ParentInstanz_ID,true);
                IPS_ApplyChanges($S7_ParentInstanz_ID);

                IPS_LogMessage("WEBFRONT_TIME", "Try to connect ... (" . $S7_connect .")");
                IPS_Sleep(1000);
                $ReconnectCounter = $ReconnectCounter + 1;
                if ($ReconnectCounter >=10)
                   {
                    IPS_LogMessage("WEBFRONT_TIME", "ERROR: Timeout bei connect mit ID="	. $S7_ParentInstanz_ID);

                    //S7-Verbindung abbauen
                    S7_SetOpen($S7_ParentInstanz_ID,false);
                    IPS_ApplyChanges($S7_ParentInstanz_ID);

                    IPS_LogMessage("WEBFRONT_TIME", "Verbindung getrennt !!");
                    echo("Fehler beim Verbindungsaufbau zur S7 !! (InsatnzID: " . $S7_ParentInstanz_ID . ")" );
                    return;
			          }
               }

         //Check ob Verbindungsinstanz zur Steuerung wirklich okay ???
         $instance = IPS_GetInstance($S7_ParentInstanz_ID);
         if ($instance['InstanceStatus'] >= 104)
            {
             IPS_LogMessage("WEBFRONT_TIME", "ERROR: Keine Verbindung zur Steuerung --> ABBRUCH !!");

             //S7-Verbindung abbauen
             S7_SetOpen($S7_ParentInstanz_ID,false);
             IPS_ApplyChanges($S7_ParentInstanz_ID);

             echo("ERROR: Keine Verbindung zur Steuerung --> Verbindung schliessen und ABBRUCH !!");
             return;
            }


       //*******************************************************************



		 $_hour = strtoupper(str_pad((int) substr($_IPS['VALUE'],0,2),2,"0",STR_PAD_LEFT));
		 $_minute = strtoupper(str_pad((int) substr($_IPS['VALUE'],3,2),2,"0",STR_PAD_LEFT));
		 
       SetValue($_IPS['VARIABLE'], $_hour . ":" . $_minute );

		 if ((int) $_hour < date("G"))
		    {
		  	  $_day = date("j") + 1;
			 }
		 else
		    {
			  if ( ((int) $_hour == date("G")) && ((int) $_minute < (int) date("i")) )
			  	  {
				   $_day = date("j") + 1;
				  }
           else
			     {
				   $_day = date("j");
				  }
			 }

      $SysTimeInput = mktime ((int) $_hour ,(int) $_minute, 0, date("n"),$_day, date("Y"));


		 //* hier koennte man das schreiben zur PLC einfuegen
		 
		 if ($_IPS['VARIABLE'] == 18127)
			 {
			  //ID der STRING Variable eintragen die durch Webfront geandert wurde und das schreiben zur S7 ausloesen soll !!
			  //
			  //als Muster wird hier die Variable welche ueber das Webfront eingeben wurde an die S7 geschrieben,
			  //es wir davon ausgegangen das in der S7 ein DB9 mit eine Datefeld "DATE_AND_TIME" von DBB4-DBB11 besteht

           IPS_LogMessage("WEBFRONT_TIME", "Schreibe Zeitstempel zur S7: " . date("y-m-d H:i:s", $SysTimeInput));

		     //YEAR ==> DB9.DBB4
		     S7_WRITE($S7_Instanz_ID,1,7,9,4,0,intval(hexdec(date("y",$SysTimeInput))));

           //MONTH ==> DB9.DBB5
           S7_WRITE($S7_Instanz_ID,1,7,9,5,0,intval(hexdec(date("m",$SysTimeInput))));

           //DAY ==> DB9.DBB6
           S7_WRITE($S7_Instanz_ID,1,7,9,6,0,intval(hexdec(date("d",$SysTimeInput))));

           //HOUR ==> DB9.DBB7
           S7_WRITE($S7_Instanz_ID,1,7,9,7,0,intval(hexdec(date("H",$SysTimeInput))));

           //MINUTE ==> DB9.DBB8
           S7_WRITE($S7_Instanz_ID,1,7,9,8,0,intval(hexdec(date("i",$SysTimeInput))));

           //SECOND ==> DB9.DBB9
           S7_WRITE($S7_Instanz_ID,1,7,9,9,0,intval(hexdec(date("s",$SysTimeInput))));
			 }

		 //****************************************************
		 
      }
   else
      {
	     echo(  "FEHLER BEI UHRZEIT EINGABE !! \r\n"
		       . "Zeitformat entspricht nicht <H1>00:00 - 23:59</H1>" . "\r\n"
		 	    . "Eingabe = '" . $_IPS['VALUE'] . "'");
      }
  }
?>